VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WebClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Event EndOfDataArrival()
Public Event DataArrival(NewData As String)
Public Event Closed()
Public Event NewHeader(TheHeader As OneHeader)
Public Event GetAnswer()
Public Event Error(ByVal Number As Long, ByVal Description As String)
Public Event StartOfDataArrival()

Public Data As String

Public answer_Version As String
Public answer_Number As Double
Public answer_Message As String
Public answer_Headers As WebClient_Header
Public answer_ContentLength As Long
Public answer_CanKeepAlive As Boolean

Public ProxyServer As String
Public ProxyPort As Long

Private WithEvents Socket As CSocketSecure
Attribute Socket.VB_VarHelpID = -1
Private WithEvents myTimer As ATimer
Attribute myTimer.VB_VarHelpID = -1
Private WithEvents SendRequestTimer As ATimer
Attribute SendRequestTimer.VB_VarHelpID = -1

Private MyAddress As String
Private MyServer As String
Private myPort As Long
Private myCommand As String
Private myPage As String
Private myHTTPVersion As String
Private myReferer As String
Private myUserAgent As String
Private myContent As String
Private myContentType As String
Private myOtherHeaders As String
Private myCookies As String
Private myUseKeepAliveConnection As Boolean

Private Status As Integer

Private AllData As String

Private LastSocketServer As String
Private LastSocketServerPort As Long

Public Sub GetPage(ByVal Adresse As String, Optional HTTP_Command As String = "GET", Optional HTTP_Version As String = "HTTP/1.1", Optional HTTP_Referer As String = "", Optional ByVal HTTP_UserAgent As String, Optional HTTP_Content As String = "", Optional HTTP_ContentType As String = "application/x-www-form-urlencoded", Optional otherHeaders As Variant = Nothing, Optional HTTP_Cookies As Variant = Nothing, Optional UseKeepAliveConnection As Boolean = False)
    StartProzess "WebClient_GetPage"
    
    If HTTP_UserAgent = "" Then
        HTTP_UserAgent = ProgrammName + "/" + MyVersion
    End If
    
    Status = 0
    Data = ""
    AllData = ""
    answer_Headers.DeleteHeaders
    answer_ContentLength = -1
    answer_CanKeepAlive = UseKeepAliveConnection
    
    Dim X As Long
    Dim F As Long
    Dim HTTP_Server As String
    Dim HTTP_Page As String
    Dim HTTP_Port As Long
        
    If UCase$(Left$(Adresse, 7)) = "HTTP://" Then Adresse = Right$(Adresse, Len(Adresse) - 7)
    
    F = InStr(Adresse, "/")
    If F = 0 Then
        HTTP_Server = Adresse
        HTTP_Page = "/"
    Else
        F = F - 1
        HTTP_Server = Left$(Adresse, F)
        HTTP_Page = Right$(Adresse, Len(Adresse) - F)
    End If
    
    F = InStr(HTTP_Server, ":")
    If F = 0 Then
        HTTP_Port = 80
    Else
        HTTP_Port = Val(Right$(HTTP_Server, Len(HTTP_Server) - F))
        HTTP_Server = Left$(HTTP_Server, F - 1)
    End If
    
    MyAddress = "http://" + Adresse
    Log_ProzessInfo "myAddress: " + MyAddress
    MyServer = HTTP_Server
    Log_ProzessInfo "myServer: " + MyServer
    myPort = HTTP_Port
    Log_ProzessInfo "myPort: " + LTrim$(RTrim$(Str$(myPort)))
    myCommand = HTTP_Command
    Log_ProzessInfo "myCommand: " + myCommand
    myPage = HTTP_Page
    Log_ProzessInfo "myPage: " + myPage
    myHTTPVersion = HTTP_Version
    Log_ProzessInfo "myHTTPVersion: " + myHTTPVersion
    myReferer = HTTP_Referer
    Log_ProzessInfo "myReferer: " + myReferer
    myUserAgent = HTTP_UserAgent
    Log_ProzessInfo "myUserAgent: " + myUserAgent
    myContent = HTTP_Content
    Log_ProzessInfo "Len(myContent) = " + LTrim$(RTrim$(Str$(Len(myContent))))
    myContentType = HTTP_ContentType
    If otherHeaders Is Nothing Then
        Log_ProzessInfo "ohterHeaders Is Nothing"
        myOtherHeaders = ""
    ElseIf TypeOf otherHeaders Is WebClient_Header Then
        Log_ProzessInfo "TypeOf otherHeaders Is WebClient_Header"
        myOtherHeaders = ""
        For X = 1 To otherHeaders.Anzahl
            myOtherHeaders = myOtherHeaders + otherHeaders.GetHeader(X).theName + ": " + otherHeaders.GetHeader(X).theValue + endl
        Next
    Else
        Log_ProzessInfo "TypeOf otherHeaders Is 'something else' (perhaps a string)"
        myOtherHeaders = otherHeaders
    End If
    Log_ProzessInfo "myOtherHeaders: " + myOtherHeaders
    If HTTP_Cookies Is Nothing Then
        Log_ProzessInfo "HTTP_Cookies Is Nothing"
        myCookies = ""
    ElseIf TypeOf HTTP_Cookies Is httpCookie Then
        Log_ProzessInfo "TypeOf HTTP_Cookies Is httpCookie"
        myCookies = HTTP_Cookies.GetString(MyAddress)
    Else
        Log_ProzessInfo "TypeOf HTTP_Cookies Is 'something else' (perhaps a string)"
        myCookies = HTTP_Cookies
    End If
    Log_ProzessInfo "myCookies: " + myCookies
    myUseKeepAliveConnection = UseKeepAliveConnection
    
    If ProxyServer = "" Then
        Log_ProzessInfo "use a direct connection to server"
        If (UseKeepAliveConnection) And (LastSocketServer = LCase$(HTTP_Server)) And (LastSocketServerPort = HTTP_Port) And (Socket.State = sockConnected) Then
            Log_ProzessInfo "use open keep-alive connection"
            Socket_Connect 'kann sofort Request senden
        Else
            Log_ProzessInfo "connect to server"
            Socket.Disconnect
            Socket.Connect HTTP_Server, HTTP_Port
            LastSocketServer = LCase$(HTTP_Server)
            LastSocketServerPort = HTTP_Port
        End If
    Else
        Log_ProzessInfo "use following proxy -> " + ProxyServer + ":" + LTrim$(RTrim$(Str$(ProxyPort)))
        If (UseKeepAliveConnection) And (LastSocketServer = LCase$(ProxyServer)) And (LastSocketServerPort = ProxyPort) And (Socket.State = sockConnected) Then
            Log_ProzessInfo "use open keep-alive connection"
            Socket_Connect 'kann sofort Request senden
        Else
            Log_ProzessInfo "connect to server"
            Socket.Disconnect
            Socket.Connect ProxyServer, ProxyPort
            LastSocketServer = LCase$(ProxyServer)
            LastSocketServerPort = ProxyPort
        End If
    End If
    
    Log_ProzessInfo "End"
    EndProzess "WebClient_GetPage"
End Sub

Private Sub Class_Initialize()
    NewInstanz "WebClient"
    
    Set Socket = New CSocketSecure
    Set answer_Headers = New WebClient_Header
    Set myTimer = New ATimer
    Set SendRequestTimer = New ATimer
    
    ProxyServer = default_ProxyServer
    ProxyPort = default_ProxyPort
    
    LastSocketServer = ""
    LastSocketServerPort = 0
End Sub

Private Sub Class_Terminate()
    Set SendRequestTimer = Nothing
    Set myTimer = Nothing
    Set answer_Headers = Nothing
    Set Socket = Nothing
    
    UnloadInstanz "WebClient"
End Sub

Private Sub myTimer_Timer()
    'Timer aufgerufen von Again()
    
    myTimer.StoppTimer
    
    Socket.Disconnect
    If ProxyServer = "" Then
        Socket.Connect MyServer, myPort
    Else
        Socket.Connect ProxyServer, ProxyPort
    End If
End Sub

Private Sub SendRequestTimer_Timer()
    Const LogThisProzess As Boolean = False
    
    If LogThisProzess Then StartProzess "WebClient_SendRequest"
    
    SendRequestTimer.StoppTimer
    
    If LogThisProzess Then Log_ProzessInfo "URL=" + MyAddress
    If LogThisProzess Then Log_ProzessInfo "Host connected"
    
    If Socket.State <> sockConnected Then
        If LogThisProzess Then Log_ProzessInfo "ERROR: Host cancelled (connection is not available)"
        If LogThisProzess Then EndProzess "WebClient_SendRequest"
        Exit Sub
    End If
    
    Dim X As Long
    
    If LogThisProzess Then Log_ProzessInfo "sending answer..."
    If ProxyServer = "" Then
        Socket.SendData myCommand + " " + myPage + " " + myHTTPVersion + endl
    Else
        Socket.SendData myCommand + " " + MyAddress + " " + myHTTPVersion + endl
    End If
    If LogThisProzess Then Log_ProzessInfo "sending referer..."
    If myReferer <> "" Then
        Socket.SendData "Referer: " + myReferer + endl
    End If
    If LogThisProzess Then Log_ProzessInfo "sending accept-info..."
    Socket.SendData "Accept: */*" + endl
    If UCase$(myHTTPVersion) = "HTTP/1.1" Then
        If LogThisProzess Then Log_ProzessInfo "sending hostname..."
        Socket.SendData "Host: " + MyServer + IIf(myPort = 80, "", ":" + LTrim$(RTrim$(Str$(myPort)))) + endl
    End If
    If LogThisProzess Then Log_ProzessInfo "sending user-agent..."
    Socket.SendData "User-Agent: " + myUserAgent + endl
    If LogThisProzess Then Log_ProzessInfo "sending accept-language..."
    Socket.SendData "Accept-Language: de" + endl
    If Not myContent = "" Then
        If LogThisProzess Then Log_ProzessInfo "sending content-length..."
        Socket.SendData "Content-Length: " + LTrim$(RTrim$(Str$(Len(myContent)))) + endl
        If LogThisProzess Then Log_ProzessInfo "sending content-type..."
        Socket.SendData "Content-Type: " + myContentType + endl
    End If
    If myCookies <> "" Then
        If LogThisProzess Then Log_ProzessInfo "sending cookies..."
        Socket.SendData "Cookie: " + myCookies + endl
    End If
    If myOtherHeaders <> "" Then
        If LogThisProzess Then Log_ProzessInfo "sending other headers..."
        Socket.SendData myOtherHeaders
    End If
    If LogThisProzess Then Log_ProzessInfo "sending connection-type..."
    If myUseKeepAliveConnection Then
        Socket.SendData "Connection: Keep-Alive" + endl
    Else
        Socket.SendData "Connection: Close" + endl
    End If
    If LogThisProzess Then Log_ProzessInfo "sending end..."
    Socket.SendData endl
    If Not myContent = "" Then
        If LogThisProzess Then Log_ProzessInfo "sending content..."
        Socket.SendData myContent
    End If
    If LogThisProzess Then Log_ProzessInfo "sending completed"

    If LogThisProzess Then EndProzess "WebClient_SendRequest"
End Sub

Private Sub Socket_Closed()
    If SendRequestTimer.GetStatus Then
        SendRequestTimer.StoppTimer
        Socket_Error 0, "Server cancelled"
    Else
        StartProzess "Event WebClient_Closed"
        On Error GoTo Fehler
        Log_ProzessInfo "URL=" + MyAddress
        RaiseEvent Closed
        On Error GoTo 0
        EndProzess "Event WebClient_Closed"
        If answer_ContentLength < 0 Then
            RaiseEvent EndOfDataArrival
        Else
            If Len(Data) < answer_ContentLength Then
                Socket_Error 0, "Server disconnected"
            End If
        End If
    End If
    Exit Sub
    
Fehler:
    Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
    Resume Next
End Sub

Private Sub Socket_Connect()
    SendRequestTimer.Delay = 100
    SendRequestTimer.Resolution = 30000
    SendRequestTimer.StartTimer
End Sub

Private Sub Socket_DataArrival(BinData As String, RemoteHostIP As String)
    Dim Temp As String
    Dim X As Integer
    Dim F As Integer
    Dim AktLine As String
    
    Temp = BinData

    If Not Status = 2 Then
        AllData = AllData + Temp
    End If
    'Debug.Assert MyServer <> "80.143.110.140"
CheckNextData:
    If Not Status = 2 Then
        F = InStr(AllData, Chr$(10))
        If F = 0 Then Exit Sub
        AktLine = Replace(Left$(AllData, F - 1), Chr$(13), "")
        AllData = Right$(Temp, Len(AllData) - F)
    End If
    Select Case Status
        Case 0 'erste Daten
            F = InStr(AktLine, " ")
            If F = 0 Then Exit Sub
            answer_Version = Left$(AktLine, F - 1)
            AktLine = Right$(AktLine, Len(AktLine) - F)
            F = InStr(AktLine, " ")
            If F = 0 Then Exit Sub
            answer_Number = Val(Left$(AktLine, F - 1))
            AktLine = Right$(AktLine, Len(AktLine) - F)
            answer_Message = AktLine
            Status = 1
            StartProzess "Event WebClient_GetAnswer"
            On Error GoTo Fehler
            Log_ProzessInfo "URL=" + MyAddress
            RaiseEvent GetAnswer
            On Error GoTo 0
            EndProzess "Event WebClient_GetAnswer"
            GoTo CheckNextData
        Case 1 'Headers
            If LTrim$(RTrim$(AktLine)) = "" Then
                Status = 2
                StartProzess "Event WebClient_StartOfDataArrival"
                On Error GoTo Fehler
                Log_ProzessInfo "URL=" + MyAddress
                RaiseEvent StartOfDataArrival
                On Error GoTo 0
                EndProzess "Event WebClient_StartOfDataArrival"
                Temp = AllData
                GoTo NewDataAvailable
            Else
                F = InStr(AktLine, ": ")
                If F = 0 Then 'eigentlich falsch, sind wahrscheinlich schon richtige Daten
                    Status = 2
                    StartProzess "Event WebClient_StartOfDataArrival"
                    On Error GoTo Fehler
                    Log_ProzessInfo "URL=" + MyAddress
                    RaiseEvent StartOfDataArrival
                    On Error GoTo 0
                    EndProzess "Event WebClient_StartOfDataArrival"
                    Temp = AktLine + Chr$(13) + Chr$(10) + AllData
                    GoTo NewDataAvailable
                End If
                Select Case UCase$(Left$(AktLine, F - 1))
                    Case "CONTENT-LENGTH"
                        answer_ContentLength = Val(Right$(AktLine, Len(AktLine) - F - 1))
                    Case "CONNECTION"
                        If UCase$(LTrim$(RTrim$(Right$(AktLine, Len(AktLine) - F - 1)))) = "KEEP-ALIVE" Then
                            answer_CanKeepAlive = True
                        Else
                            answer_CanKeepAlive = False
                        End If
                End Select
                answer_Headers.NewHeader GetNewHeader(Left$(AktLine, F - 1), Right$(AktLine, Len(AktLine) - F - 1))
                StartProzess "Event WebClient_NewHeader"
                On Error GoTo Fehler
                Log_ProzessInfo "URL=" + MyAddress
                Log_ProzessInfo answer_Headers.GetLastHeader().theName + ": " + answer_Headers.GetLastHeader().theValue
                RaiseEvent NewHeader(answer_Headers.GetLastHeader())
                On Error GoTo 0
                Log_ProzessInfo "Ende"
                EndProzess "Event WebClient_NewHeader"
                GoTo CheckNextData
            End If
        Case 2 'Daten
NewDataAvailable:
            If Not Temp = "" Then
                Data = Data + Temp
                StartProzess "Event WebClient_DataArrival"
                On Error GoTo Fehler
                Log_ProzessInfo "URL=" + MyAddress
                Log_ProzessInfo "Data=" + Temp
                RaiseEvent DataArrival(Temp)
                On Error GoTo 0
                EndProzess "Event WebClient_DataArrival"
            End If
            If answer_ContentLength >= 0 Then
                If Len(Data) >= answer_ContentLength Then
                    RaiseEvent EndOfDataArrival
                End If
            End If
            Exit Sub
    End Select
    Exit Sub
    
Fehler:
    Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
    Resume Next
End Sub

Private Sub Socket_Error(Error As Long, Description As String)
    Socket.Disconnect
    StartProzess "Event WebClient_Error"
    On Error GoTo Fehler
    Log_ProzessInfo "URL=" + MyAddress
    Log_ProzessInfo "Nr: " + LTrim$(RTrim$(Str$(Error)))
    Log_ProzessInfo "Description: " + Description
    RaiseEvent Error(Error, Description)
    On Error GoTo 0
    EndProzess "Event WebClient_Error"
    Exit Sub
    
Fehler:
    Log_ProzessInfo "Fehler " + LTrim$(RTrim$(Str$(Err.Number))) + ": " + Err.Description
    Resume Next
End Sub

Public Sub Again(Optional WaitTime As Long = 5000)
    myTimer.Delay = WaitTime
    myTimer.Resolution = 30000
    myTimer.StartTimer
End Sub

Public Sub Cancel() 'muss vor Terminate ausgefhrt werden!
    If Not myTimer Is Nothing Then myTimer.StoppTimer
    If Not Socket Is Nothing Then Socket.Cancel
    If Not SendRequestTimer Is Nothing Then SendRequestTimer.StoppTimer
End Sub

Public Sub SetProxy(TheAddress As String)
    Dim F As Integer
    F = InStr(TheAddress, ":")
    If F = 0 Then
        ProxyServer = TheAddress
        ProxyPort = 8080
    Else
        ProxyServer = Left$(TheAddress, F - 1)
        ProxyPort = Val(Right$(TheAddress, Len(TheAddress) - F))
    End If
End Sub

Public Function GetAdresse() As String
    GetAdresse = MyAddress
End Function

Public Sub Disconnect()
    myTimer.StoppTimer
    Socket.Disconnect
End Sub
