VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form WinsockServer_Form 
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
   Begin MSWinsockLib.Winsock Clients 
      Index           =   0
      Left            =   600
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin MSWinsockLib.Winsock Listener 
      Left            =   120
      Top             =   120
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      Protocol        =   1
   End
End
Attribute VB_Name = "WinsockServer_Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Event Error(ByVal Index As Long, ByVal Number As Integer, ByVal Description As String)
Public Event NewClient(ByVal Index As Long)
Public Event SendComplete(ByVal Index As Long)
Public Event DataArrival(ByVal Index As Long, Data As String)
Public Event Closed(ByVal Index As Long)

Private myClass As CSocket_Server

Public Sub SetClass(TheClass As CSocket_Server)
 Set myClass = TheClass
End Sub

Public Function Listen(ByVal Port As Long) As Integer
    On Error GoTo CannotListen
    Select Case Listener.Protocol
        Case sckTCPProtocol
            Listener.LocalPort = Port
            Listener.Listen
        Case sckUDPProtocol
            Listener.LocalPort = Port
            Listener.bind Port
    End Select
    Listen = 0
    Exit Function
    
CannotListen:
    Log "ERROR: cannot listen to " + IIf((Listener.Protocol = sckTCPProtocol), "tcp", "udp") + " port " + LTrim$(RTrim$(Str$(Port)))
    Listen = -1
    Exit Function
End Function

Public Sub Disconnect(ByVal Index As Long)
 If Index = 0 Then
  Dim X As Long
 
  For X = 1 To Clients.UBound
   Clients(X).Close
  Next
  
  X = Clients.UBound
  Do While Not X = 0
   Unload Clients(X)
   X = Clients.UBound
  Loop
 
  Listener.Close
 Else
  If Index > Clients.UBound Then Exit Sub
  Clients(Index).Close
  Do While (GetState(Clients.UBound) = sockClosed) _
       And (Clients.UBound <> 0)
   Unload Clients(Clients.UBound)
  Loop
 
 End If
End Sub

Private Sub Clients_Close(Index As Integer)
 Disconnect Index
 RaiseEvent Closed(Index)
End Sub

Private Sub Clients_DataArrival(Index As Integer, ByVal bytesTotal As Long)
    Dim Temp As String
    Temp = Space$(bytesTotal)
    On Error GoTo Fehler
    Clients(Index).GetData Temp
    On Error GoTo 0
    RaiseEvent DataArrival(Index, Temp)
    Exit Sub
    
Fehler:
    Dim ErrNr As Long
    Dim ErrDesc As String
    ErrNr = Err.Number
    ErrDesc = Err.Description
    Resume Fehlerbehandlung
    
Fehlerbehandlung:
    On Error GoTo 0
    Clients_Error Index, ErrNr, ErrDesc, 0, "", "", 0, False
    Exit Sub
End Sub

Public Sub SendData(ByVal Index As Long, ByVal Data As String)
    If Index = 0 Then
        Listener.SendData Data
    Else
        Clients(Index).SendData Data
    End If
End Sub

Private Sub Clients_Error(Index As Integer, ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
 Clients(Index).Close
 RaiseEvent Error(Index, Number, Description)
End Sub

Private Sub Clients_SendComplete(Index As Integer)
 RaiseEvent SendComplete(Index)
End Sub

Public Function GetPort(ByVal Index As Long) As Long
 If Index = 0 Then
  GetPort = Listener.LocalPort
 Else
  GetPort = Clients(Index).LocalPort
 End If
End Function

Public Function GetClientIP(ByVal Index As Long) As String
 GetClientIP = Clients(Index).RemoteHostIP
End Function

Public Function GetServerIP(ByVal Index As Long) As String
 GetServerIP = Clients(Index).LocalIP
End Function

Private Sub Form_Load()
    NewInstanz "WinsockServer_Form"
End Sub

Private Sub Form_Unload(Cancel As Integer)
    UnloadInstanz "WinsockServer_Form"
End Sub

Private Sub Listener_ConnectionRequest(ByVal requestID As Long)
 Dim X As Long
 For X = 1 To Clients.UBound
  If GetState(X) = sockClosed Then
ConnectSocket:
   Clients(X).Accept requestID
   RaiseEvent NewClient(X)
   Exit Sub
  End If
 Next
 
 Load Clients(Clients.UBound + 1)
 X = Clients.UBound
 GoTo ConnectSocket
End Sub

Private Sub Listener_DataArrival(ByVal bytesTotal As Long)
    Dim Temp As String
    Temp = Space$(bytesTotal)
    On Error GoTo Fehler
    Listener.GetData Temp
    On Error GoTo 0
    RaiseEvent DataArrival(0, Temp)
    Exit Sub
    
Fehler:
    Dim ErrNr As Long
    Dim ErrDesc As String
    ErrNr = Err.Number
    ErrDesc = Err.Description
    Resume Fehlerbehandlung
    
Fehlerbehandlung:
    On Error GoTo 0
    Listener_Error ErrNr, ErrDesc, 0, "", "", 0, False
    Exit Sub
End Sub

Private Sub Listener_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    RaiseEvent Error(0, Number, Description)
End Sub

Public Function GetState(ByVal Index As Long) As sockType
 Dim TheWinsock As Winsock
 If Index = 0 Then
  Set TheWinsock = Listener
 Else
  Set TheWinsock = Clients(Index)
 End If
 Select Case TheWinsock.State
  Case sckClosed
   GetState = sockClosed
  Case sckOpen
   GetState = sockClosed
  Case sckListening
   GetState = sockListening
  Case sckConnectionPending
   GetState = sockConnecting
  Case sckResolvingHost
   GetState = sockConnecting
  Case sckHostResolved
   GetState = sockConnecting
  Case sckConnecting
   GetState = sockConnecting
  Case sckConnected
   GetState = sockConnected
  Case sckClosing
   GetState = sockClosed
  Case sckError
   GetState = sockClosed
 End Select
End Function

Public Sub Cancel()
 Log "Server_Cancel"
 Disconnect 0
 Set myClass = Nothing
End Sub

Private Sub Listener_SendComplete()
    RaiseEvent SendComplete(0)
End Sub
